;
; super wonder boy - round 11 patch
; mailto:jp@drumfu.com
; september/october 2013
;
; patch to apply fixes by ralf and bandit
; to super wonderboy in monsterland round 11 level data
; http://www.worldofspectrum.org/forums/showthread.php?t=44653
;
	org $8000
;
	call $0d6b	; cls
	ld a,$02
	call $1601	; chan-open
;
	ld hl,banner0
	call prtstr
;
	call blockld
;
	call patch
;
	call blocksv
;
	ret
;
blocksv	ld hl,savemsg
	call prtstr
	call enterp
	call block1
	call save
	jr nc,break
	call block2
	call save
	jr nc,break
	call block3
	call save
	jr nc,break
	ld hl,donemsg
	call prtstr
	ret
;
break	ld hl,brkmsg
	call prtstr
	ret
;
blockld	ld hl,loadmsg
	call prtstr
	call enterp
load1	call block1
	call loader
load2	call block2
	call loader
load3	call block3
	call loader
;
	call block1
	push de
	pop bc
	push ix
	pop de
	call getcrc
	ld de,(check1)
	and a
	sbc hl,de
	jr nz,load1

	call block2
	push de
	pop bc
	push ix
	pop de
	call getcrc
	ld de,(check2)
	and a
	sbc hl,de
	jr nz,load1

	call block3
	push de
	pop bc
	push ix
	pop de
	call getcrc
	ld de,(check3)
	and a
	sbc hl,de
	jr nz,load1
	ret
;

;
patch	ld hl,ptchmsg
	call prtstr
;
	ld a,$ac
	ld ($df70),a		; enable dragon
;
	ld a,$23
	ld ($7eae),a		; correct victory message scroll screen address
;
	ld hl,patch1
	ld de,$bd31
	ld bc,epatch1-patch1
	ldir
;
	ld hl,firebl
	ld de,$7f6c
	ld ($bd45),de
	ld bc,efirebl-firebl
	ldir
;
	ld a,$c3		; jp op-code
	ld ($bd44),a
;
	ret
;
patch1	ld a,r
	and $01
epatch1	equ $
;
firebl	jp nz,$bd48
	ld de,$bdbd		; points to 8,9,10,11	
	ld a,(iy+$05)		; dragon direction 0=left, 1=right
	or a
	jr z,fireblf		; fire left if dragon facing left
	ld e,$ba		; fire right if dragon facing right (points to 5,6,7,8)
fireblf	ld a,r
	and $03
	add a,e
	ld e,a
	ld a,(de)
	ld (hl),a
	jp $bd48
efirebl	equ $
;
block1	ld ix,$7a00
	ld de,$0585
	ld a,$01
	ret
block2	ld ix,$b3f4
	ld de,$0a1c
	ld a,$02
	ret
block3	ld ix,$d7e0
	ld de,$261d
	ld a,$03
	ret
;
;
enterp	ld a,$bf
	in a,($fe)
	and $01
	ret z
	jr enterp
;
;
banner0	defm "super wonder boy round 11 bugfix",$0d
	defm "mailto:jp@drumfu.com "
version	defm "v1.1",$0d
	defm $0d,"kudos & props: ralf, metalbrain,",$0d
	defm " bandit, goodboy, sinus, slider,",$0d
	defm " baze (for checksum code),",$0d
	defm "  and speedlock associates...",$0d
	defb $00
;
loadmsg	defm $0d," press enter and play round 11",$0d,$00
savemsg	defm $0d," start recording and press enter",$0d,$00
ptchmsg	defm $0d," patching...",$0d,$00
donemsg	defm $0d," all done!",$00
brkmsg	defm $0d," break!",$0d,$00
;
prtstr	ld a,(hl)
	cp $00
	ret z
	rst $10
	inc hl
	jr prtstr
;
check1	defw $0353
check2	defw $fdc3
check3	defw $d0be
;
; 16 bit crc-ccitt checksum
; adapted from baze's z80 bits
; http://baze.au.com/misc/z80bits.html
;
; input: de=address of input data
;        bc=number of bytes to process
; output: hl = CRC 
;
getcrc	ld hl,$ffff
	push bc
crcrd	ld a,(de)
	inc de
	xor h
	ld h,a
	ld b,8
crcbyt	add hl,hl
	jp nc,crcnxt
	ld a,h
	xor $10
	ld h,a
	ld a,l
	xor $21
	ld l,a
crcnxt	djnz crcbyt
	pop bc
	dec bc
	push bc
	ld a,b
	or c
	jp nz,crcrd
	pop bc
	ret
;

; spectrum fast load &  save routines for use within games.
; copyright 1989 speedlock associates
; written by david aubrey jones
; must not be used without permission from speedlock associates
; tel.0734 470303 / 0793 870525

;	org 8000h		; must be in uncontended ram

; example of use
; -saving and loading a screen

tsave	ld ix,$4000
	ld de,$1b00
	ld a,$ff
	call save
	ret 

tload	ld ix,$4000
	ld de,$1b00
	ld a,$ff
	call loader
;error routine
	ret 

;save routines
;
save	ld hl,back
	push hl
	ld hl,$0c98
sflag	ex af,af'
	inc de
	dec ix
	di 
	ld a,$02
	ld b,a
slead	djnz slead
	out ($fe),a
	xor $0f
	ld b,$a4
	dec l
	jr nz,slead
	dec b
	dec h
	jp p,slead
	ld b,$2f
sync1	djnz sync1
	out ($fe),a
	ld a,$0d
	ld b,$37
sync2	djnz sync2
	out ($fe),a
	ld bc,$3b0e
	ex af,af'
	ld l,a
	jp sst
sloop	ld a,d
	or e
	jr z,spar
	ld l,(ix+$00)
slpp	ld a,h
	xor l
sst	ld h,a
	ld a,$01
	scf 
	jp s8bit
spar	ld l,h
	jr slpp
sbit2	ld a,c
	bit 7,b
sbit1	djnz sbit1
	jr nc,sout
	ld b,$2e
sset	djnz sset
sout	out ($fe),a
	ld b,$2a
	jr nz,sbit2
	dec b
	xor a
	inc a
s8bit	rl l
	jp nz,sbit1
	dec de
	inc ix
	ld b,$1d
	ld a,$7f
	in a,($fe)
	rra 
	ret nc
	ld a,d
	inc a
	jp nz,sloop
	ld b,$3b
sdel	djnz sdel
	ret 

back	push af
; black border at end
	xor a
	out ($fe),a
	ei 
	pop af
	ret
;
;	ret c
;
;err	rst $8
;	defb $1a

; load routines
;
loader	di 
	or a
	scf 
	ex af,af'
	ld a,$02
	ld (bor+$01),a
	ld a,$0f
	out ($fe),a
	ld hl,back
	push hl
	in a,($fe)
	rra 
	and $20
	ld c,a
lstart	ld h,$00
llead	ld b,$90
	call ledg2
	jr nc,lstart
	ld a,$bf
	cp b
	jr nc,lstart
	inc h
	jr nz,llead
lsync	ld b,$c3
	call ledg1
	jr nc,lstart
	ld a,b
	cp $d4
	jr nc,lsync
	call ledg1
	ret nc
	ld a,$01
	ld (bor+$01),a
	ld h,$00
	ld b,$c0
	jr lmark
lloop	ex af,af'
	jr nz,lflg
	jr nc,lver
	ld (ix+$00),l
	jr lnext
lflg	rl c
	xor l
	ret nz
	ld a,c
	rra 
	ld c,a
	inc de
	jr ldec
lver	ld a,(ix+$00)
	xor l
	ret nz
lnext	inc ix
ldec	dec de
	ex af,af'
	ld b,$c2
lmark	ld l,$01
l8b	call ledg2
	ret nc
	ld a,$db
	cp b
	rl l
	ld b,$c0
	jp nc,l8b
	ld a,h
	xor l
	ld h,a
	ld a,d
	or e
	jr nz,lloop
	ld a,h
	cp $01
	ret 
;
ledg2	call ledg1
	ret nc
ledg1	and a
lsamp	inc b
	ret z
	ld a,$7f
	in a,($fe)
	rra 
	ret nc
	xor c
	and $20
	jr z,lsamp
	ld a,c
	cpl 
	ld c,a
bor	and $02
	or $08
	out ($fe),a
	scf 
	ret 
;
	end
;

