; 
; super wonderboy in monsterland patch speedlock 7
; sega master mix
; mailto:jp@drumfu.com
; august 2013
;
; v1.1 october(!) 2013, stick rest of the fixes in
; v1.2 october 2013, 	updates to cleartable routine
;			and new levelcheck for a completed game
;
; patch to apply fixes by ralf, metalbrain and bandit
; to speedlock 7 release of super wonderboy in monsterland
; http://www.worldofspectrum.org/forums/showthread.php?t=44653
;
; this routine adapted from jon north's how to hack article
; http://www.worldofspectrum.org/showwrap.cgi?page=hth63.html
;
ldto	equ first-$60		; start address of basic
ldlen	equ $11a4		; basic length
first	equ $eda5		; address of first decrypter
;last	equ $0000		; address of last decrypter on speedlock 7
initr	equ $0c-$01		; initial value of r
; 
	org $8000
;
ldbas	ld ix,ldto		; start address
	ld de,ldlen		; length
	ld a,$ff
	scf
	call $0556		; standard headerless load
	jr nc,ldbas		; go back if load is unsuccessful
;
	di			; so that r does not get corrupted
dcrlp	ld hl,first		; address of first decrypter
	ld a,(hl)		; a=first byte
	cp $c3			; is it a c3, ie a jp?
	jr nz,type3		; go forward if not
	inc hl			; otherwise go past it. jp takes 3 bytes
	inc hl
	inc hl
type3	ld a,(hl)		; a=first byte
	cp $31			; is it a 31, ie a ld sp?
	jr nz,chkb8		; go forward if not
	ld bc,15		; otherwise must be type 3
patch	add hl,bc		; hl=address after jp pe
	ld e,(hl)		; get the value out
	ld (hl),back&$ff	; patch in lsb of "back"
	inc hl			; next byte
	ld d,(hl)		; get the value out
	ld (hl),back&$ff00/$ff	; patch in msb of "back"
ldgme	ld hl,(dcrlp+1)		; hl is now first byte of decrypter
	ld (dcrlp+1),de		; de is address of next decrypter
	push hl			; stick address of decrypter onto stack
keepr	ld a,initr		; initial value of r
	ld r,a
	ret			; to decrypter (after that push)
chkb8	ld bc,10
	add hl,bc		; go forward 10 bytes
	ld a,(hl)		; a=value at this address
	cp $b8			; is it a b8?
	jr nz,notb8		; go forward if not, we're in the decrypter itself now
	add hl,bc		; otherwise add another 10 so we're in the dectypter itself
notb8	ld a,(hl)		; get the byte at this address
type1	cp $b3			; is it a b3?
	jr nz,type2		; go forward if not
	ld c,11			; otherwise it must be type 1, which is 11 bytes long
	ld a,249		; jr nz will go to dec (hl)
	jr dodcr		; go forward
type2	cp $dd			; is byte at hl a dd?
	jr nz,type4		; go forward if not
	ld c,23			; otherwise must be type 2, so go forward 23 bytes
	jr patch		; and patch in similar to type 3
type4	cp $77			; is byte at hl a 77?
	jr nz,type5		; go forward if not
	ld c,25			; otherwise it must be type 4, which is 25 bytes long
	ld a,246		; offset for jr nz
	jr dodcr		; do the decrypter
type5	cp $ae			; is byte at hl a ae?
	jr z,patch		; if so, crack similar to type 3. go forward 10 bytes, bc is 10 already
type6	cp $aa			; is byte at hl a aa?
	jr nz,chk5f		; go forward if not
	ld c,27			; otherwise it must be type 6, which is 27 bytes long
	ld a,244		; offset for jr nz
	jr dodcr		; go forward to do the decrypter
chk5f	cp $5f			; is byte at hl a 5f?
	jr nz,type9		; go forward if not
type7	inc hl			; otherwise it could be either type 7 or 8
	ld a,(hl)		; check following byte to decide whether it's a type 7 or 8
	cp $aa			; is it a aa?
	jr z,type8		; go forward if it is
	ld c,28			; otherwise it must be type 7, which is 28 bytes long
	ld a,245		; offset for jr nz
	jr dodcr		; go forward and do the decrypter
type8	ld c,29			; must be type 8 if byte was aa, which is 29 bytes long
	ld a,244		; offset for jp nz
	jr dodcr		; do the decrypter
type9	cp $01			; is byte at hl a 1?
	jr nz,done		; must be finished if not because byte is not recognised
	ld c,37			; type 9 is 37 bytes long
	ld a,243		; offset for jr nz
dodcr	ld (dcrend+1),a		; patch the value of a into jr nz
	ld hl,(dcrlp+1)		; hl=address of start of decrypter
	ld de,$4000		; a convenient address
	push de			; stick 16384 onto the stack
	ld a,(hl)		; a=first byte
	cp $c3			; is it a c3, ie a jp?
	jr nz,notjp		; go forward if not
	inc c			; otherwise add 3 to length of decrypter
	inc c
	inc c
	ld (hl),33		; overwrite c3 with 33, which is ld hl,num and is harmless
notjp	ldir			; copy the decrypter down
	inc hl			; go past the jp nz in the decrypter. jp nz takes 3 bytes
	inc hl
	inc hl
	ld (dcrlp+1),hl		; hl is now the start of the next decrypter
	ld hl,dcrend		; hl=start of the bit to stick on the end
	ld c,$05		; this bit is 5 bytes long
	ldir			; copy it down onto the end
	jr keepr		; go backwards to keep track of r
dcrend	jr nz,$			; this is the jr nz we're sticking on the end
	jp back2		; and a jp to "back2"
back	ld a,r			; come back here on types 2, 3 and 5 (where we patch numbers in)
dor	sub 3			; subtract 2 for the ld a,r and one for the jp to decrypter
	res 7,a			; ensure bit 7 is reset
	ld (keepr+1),a		; keep the new value for next time
	jp dcrlp		; and loop back to do it all again
back2	ld a,r			; come back here on the other types, where we copy the decrypter somewhere
	dec a			; need to subtract an extra 1 for the jp back to this hacking routine
	jr dor			; go back to sort out r
;
done	equ $
;	ld hl,last		; address of the nop
;	ld (hl),$c3		; stick a jp in
;	inc hl			; point to next byte
;	ld (hl),back3&$ff	; stick in lsb of "back3"
;	inc hl			; point to next byte
;	ld (hl),back3&$ff00/$ff	; stick in msb of "back3"
;	ld de,nnnn		; start of decrypter
;	jp ldgme		; do the decrypter
;back3	jp nz,$nnnn		; the jp nz we've overwritten by the jp back3
;
	ld hl,pokes		; start of pokes
	ld de,pbuffer		; a safe place
	ld ($fe16),de		; standard speedlock patch
	ld bc,endp-pokes	; length
	ldir			; copy pokes down
;
	ld hl,$0000		; stop printer buffer getting cleared
	ld ($fbba),hl		; by removing ldir instruction
	jp ldgme		; load the game
;
pbuffer	equ $5b00		; workspace for pokes
patchde	equ $fe00		; destination for patches
;
pokes	equ $			; stick your pokes here
loffset	equ pokes - pbuffer	; offset between pokes and printer buffer
;
nostart	ld de,$5b08		; stop game from starting by updating
	ld ($5e0b),de		; the jump to the payload
	ret
;
payload	ld hl,fixboth-loffset	; address the table of fixes
;
; check for 128k model - geoff wearmouth, more details:
; https://groups.google.com/d/msg/comp.sys.sinclair/z5VEA8Kt4W4/52DKJ6RoLuAJ
;
chk128k	ld a,($004b)
	cp $6e
	jr z,applyfx
;
; for 48k only pause, fix the code that immediately follows
; all the out (c), r[egister] instructions
;
fixpse	ld bc,$0500		; set-up loop counter to fix 5 blocks of code
	ld hl,$b068		; address the first block of code, less $22 bytes
fxpselp	push bc			; preserve loop counter
	ld de,$0022		; offset to the block of code to fix
	add hl,de		; and update hl to point there
	ld d,h			; copy hl pair
	ld e,l			; to de pair
	push hl			; copy hl pair
	pop ix			; to ix
	inc (ix+$04)		; and increment the jr nz offset 
	inc l			; now increment hl
	ld a,b			; fetch the loop counter
	ld bc,$0009		; and prepare to copy 9 bytes
	cp $01			; is this the last loop?
	jr nz,fxpscpy		; no, go do the copy
	ld c,$04		; only need to copy 4 bytes for last loop
fxpscpy	ldir			; copy
	xor a			; prepare a nop
	ld (de),a		; and insert
	pop bc			; now restore loop counter
	djnz fxpselp		; and go again
;
	ld hl,fix48k-loffset	; point to the 48k specific fixes
applyfx	call pokebyt-loffset	; and poke them in
;
	ld hl,updates-loffset
	ld de,patchde
	ld bc,endp-updates
	ldir			; copy updated routines into place
;
; and insert jumps to updated routines - not pleasant, but works
;
	ld a,$c3		; prepare a 'jp' op-code
	ld ($97be),a		; and insert
	ld hl,$fe00		; now address the 'preserve boss pointer' routine
	ld ($97bf),hl		; and insert that address
;
	ld ($b003),a		; insert jp op-code
	ld l,$0a		; address low byte of pause routine
	ld ($b004),hl		; and insert
;
	ld ($9e3a),a		; insert jp op-code
	ld l,$2f		; address low byte of corrpta routine
	ld ($9e3b),hl		; and insert
;
	ld ($a759),a		; insert jp op-code
	ld l,$3d		; address low byte of corrptb routine
	ld ($a75a),hl		; and insert
;
	ld ($984d),a		; insert jp op-code
	ld l,$44		; address low byte of clrtbl routine
	ld ($984e),hl		; and insert
;
				; call z op-code already present so just address
	ld l,$54		; the missing dragon code
	ld ($9d57),hl		; and insert
;
	ld ($6648),a		; insert jp op-code
	ld l,$7b		; address low byte of levchk routine
	ld ($6649),hl		; and insert
;
	jp $c801		; finally, start the game
;
pokebyt	ld e,(hl)		; fetch low byte of address to poke
	inc hl			; advance pointer
	ld d,(hl)		; fetch high byte of address to poke
	ld a,d			; place high byte in accumulator
	or e			; end of data marker?
	ret z			; no further addresses or values
	inc hl			; advance pointer
	ld a,(hl)		; fetch value to poke in
	inc hl			; advance pointer to next address
	ld (de),a		; poke value into address
	jr pokebyt		; continue fetching addresses and values
;
fix48k				; 48k specific fixes only
fxmenu	defw $65de		; fix menu display for 48k - smooth 'enter to play'
	defb $02		; ld b,$02
fxpause	defw $b059		; fix initial 48k timing pause
	defb $72		; ld bc,$0172
;
fixboth				; fixes that apply to both 48k and 128k
fxtimer	defw $686a		; fix timer corruption
	defb $07		; ld sp,$7307
fxrfdrg	defw $aa59		; fix right facing dragon corruption
	defb $06		; and a,$06
fxheart	defw $6a17		; fix bug in heart bonus code
	defb $3f		; srl a
	defw $6a19		; continuation of heart bonus fix
	defb $3f		; srl a
	defw $ff57		; can pause game on boss screen
	defb $00		; jr nz,$ff58
emarker	defw $0000		; end of data marker
;
; additional fixes
;
updates
bossprs	ld (bossptr),iy		; preserve current boss pointer
	ld a,(iy+$06)
	jp $97c1
bpause	ld a,($71e2)
	or a			; boss?
	jr nz,bpause2		; yes, so custom pause
	call $6a89		; no, so normal pause
bpause1	jp $afc8
bpause2	ld a,$c9		; ret op-code
	ld ($97dd),a		; update with ret
	push iy
	ld iy,(bossptr)		; current boss pointer
	call $97be		; apply boss colours
	pop iy
	ld a,$fb		; ei op-code
	ld ($97dd),a		; restore ei
	jr bpause1
	defw $0000		; bossptr word
bossptr	equ $fe2d
;
corrpta	ld a,(ix+$02)		; graphical corruption (falling off screen)
	cp $c0
	jp nc,$9e3d
	sbc hl,de
	ret c
	jp $9e3d
;
corrptb	rrca			; left facing dragon corruption (see above for right facing fix)
	and $1f
	dec a
	jp $a75c
;
clrtbl	ld a,($71d2)		; fetch the level number
	cp $1f			; is this the last round?
	jr nz,noclear		; no, don't clear enemy table
	call $6c52		; clear enemy table when entering dragon room [to free fireball opportunities]
noclear	call $c608
	jp $9850		
;
dragon	ld a,(iy+$04)
	cp $2c			; normal dragon?
	jr z,ndragon		; yes
	cp $2d			; robot dragon?
	jr z,rdragon		; yes
	jp $c708		; other enemy
;ndragon	ld (iy+$04),$2d ; routine # to change to robot dragon
ndragon	inc (iy+$04)		; routine # to change to robot dragon
	ld (iy+$0d),$32		; 50 hits required to kill dragon
	jr edragon
rdragon	ld (iy+$04),$30		; call the end routine # (victory message) break $9004 (routine at $bd7a)
	ld (iy+$06),$00
	ld (iy+$07),$00
edragon	pop hl
	jp $9d68
;
levchk	ld a,($71d2)		; fetch level number
	cp $20			; last level?
	jp nz,$664b		; no
	call $69cb		; yes
	call $69ae		; adjust high score
	jp $7fa2		; restart game
;
endp	equ $
;

